using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace SASUnitMod
{
    public class SASUnitMod
    {
		 public static void Main()
        {
            ModAPI.Register(
                 new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "SAS Mod B Squadron Soldier",
                    DescriptionOverride = "Ready For Action.",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("SAS_Thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("SAS_Skin.png");
                        var flesh = ModAPI.LoadTexture("humanflesh.png");
                        var bone = ModAPI.LoadTexture("humanbone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
						
						var person = Instance.GetComponent<PersonBehaviour>();

			            
			            person.SetBodyTextures(skin, null, null, 1);

			            
			            person.SetBruiseColor(119, 17, 17); 
			            person.SetSecondBruiseColor(7, 0, 0); 
			            person.SetThirdBruiseColor(3, 0, 0); 
			            person.SetRottenColour(202, 199, 104); 
			            person.SetBloodColour(108, 0, 4); 
                    }
                }
            );
	        ModAPI.Register(
                 new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "SAS Mod Hazmat Soldier",
                    DescriptionOverride = "Ready For Action.",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("Hazmat_Tactical_Thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("Hazmat_Tactical_Skin.png");
                        var flesh = ModAPI.LoadTexture("humanflesh.png");
                        var bone = ModAPI.LoadTexture("humanbone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
						
						var person = Instance.GetComponent<PersonBehaviour>();

			            
			            person.SetBodyTextures(skin, null, null, 1);

			            
			            person.SetBruiseColor(119, 17, 17); 
			            person.SetSecondBruiseColor(7, 0, 0); 
			            person.SetThirdBruiseColor(3, 0, 0); 
			            person.SetRottenColour(202, 199, 104); 
			            person.SetBloodColour(108, 0, 4); 
                    }
                }
            );
	        ModAPI.Register(
                 new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "SAS Mod Elite Soldier",
                    DescriptionOverride = "Ready For Action.",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("Elite_Thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("Elite_Skin.png");
                        var flesh = ModAPI.LoadTexture("humanflesh.png");
                        var bone = ModAPI.LoadTexture("humanbone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
						
						var person = Instance.GetComponent<PersonBehaviour>();

			            
			            person.SetBodyTextures(skin, null, null, 1);

			            
			            person.SetBruiseColor(119, 17, 17); 
			            person.SetSecondBruiseColor(7, 0, 0); 
			            person.SetThirdBruiseColor(3, 0, 0); 
			            person.SetRottenColour(202, 199, 104); 
			            person.SetBloodColour(108, 0, 4); 
                    }
                }
            );
	        ModAPI.Register(
                 new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "SAS Mod HECU Soldier",
                    DescriptionOverride = "Ready For Action.",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("HECU_Thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("HECU_Skin.png");
                        var flesh = ModAPI.LoadTexture("humanflesh.png");
                        var bone = ModAPI.LoadTexture("humanbone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
						
						var person = Instance.GetComponent<PersonBehaviour>();

			            
			            person.SetBodyTextures(skin, null, null, 1);

			            
			            person.SetBruiseColor(119, 17, 17); 
			            person.SetSecondBruiseColor(7, 0, 0); 
			            person.SetThirdBruiseColor(3, 0, 0); 
			            person.SetRottenColour(202, 199, 104); 
			            person.SetBloodColour(108, 0, 4); 
                    }
                }
            );
	        ModAPI.Register(
                 new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "SAS Mod Navy Soldier",
                    DescriptionOverride = "Ready For Action.",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("Navy_Thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("Navy_Skin.png");
                        var flesh = ModAPI.LoadTexture("humanflesh.png");
                        var bone = ModAPI.LoadTexture("humanbone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
						
						var person = Instance.GetComponent<PersonBehaviour>();

			            
			            person.SetBodyTextures(skin, null, null, 1);

			            
			            person.SetBruiseColor(119, 17, 17); 
			            person.SetSecondBruiseColor(7, 0, 0); 
			            person.SetThirdBruiseColor(3, 0, 0); 
			            person.SetRottenColour(202, 199, 104); 
			            person.SetBloodColour(108, 0, 4); 
                    }
                }
            );
	        ModAPI.Register(
                 new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "SAS Mod Spec Ops Soldier",
                    DescriptionOverride = "Ready For Action.",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("Spec_Ops_Thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("Spec_Ops_Skin.png");
                        var flesh = ModAPI.LoadTexture("humanflesh.png");
                        var bone = ModAPI.LoadTexture("humanbone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
						
						var person = Instance.GetComponent<PersonBehaviour>();

			            
			            person.SetBodyTextures(skin, null, null, 1);

			            
			            person.SetBruiseColor(119, 17, 17); 
			            person.SetSecondBruiseColor(7, 0, 0); 
			            person.SetThirdBruiseColor(3, 0, 0); 
			            person.SetRottenColour(202, 199, 104); 
			            person.SetBloodColour(108, 0, 4); 
                    }
                }
            );
			//Infected Variants
	        ModAPI.Register(
                 new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "SAS Mod HECU Infected Soldier",
                    DescriptionOverride = "Ready For Action.",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("HECU_Zombie_Thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("HECU_Zombie_Skin.png");
                        var flesh = ModAPI.LoadTexture("humanflesh.png");
                        var bone = ModAPI.LoadTexture("humanbone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
						
						var person = Instance.GetComponent<PersonBehaviour>();

			            
			            person.SetBodyTextures(skin, null, null, 1);

			            
			            person.SetBruiseColor(119, 17, 17); 
			            person.SetSecondBruiseColor(7, 0, 0); 
			            person.SetThirdBruiseColor(3, 0, 0); 
			            person.SetRottenColour(202, 199, 104); 
			            person.SetBloodColour(108, 0, 4); 
				        foreach(var body in person.Limbs)
                        {
                            body.GetComponent<SkinMaterialHandler>().RottenProgress = 100f;
                            body.IsZombie = true;
                        }
                    }
                }
            );
	        ModAPI.Register(
                 new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "SAS Mod B Squadron Infected Soldier",
                    DescriptionOverride = "Ready For Action.",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("SAS_Zombie_Thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("SAS_Zombie_Skin.png");
                        var flesh = ModAPI.LoadTexture("humanflesh.png");
                        var bone = ModAPI.LoadTexture("humanbone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
						
						var person = Instance.GetComponent<PersonBehaviour>();

			            
			            person.SetBodyTextures(skin, null, null, 1);

			            
			            person.SetBruiseColor(119, 17, 17); 
			            person.SetSecondBruiseColor(7, 0, 0); 
			            person.SetThirdBruiseColor(3, 0, 0); 
			            person.SetRottenColour(202, 199, 104); 
			            person.SetBloodColour(108, 0, 4); 
				        foreach(var body in person.Limbs)
                        {
                            body.GetComponent<SkinMaterialHandler>().RottenProgress = 100f;
                            body.IsZombie = true;
                        }
                    }
                }
            );
	        ModAPI.Register(
                 new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "SAS Mod Hazmat Infected Soldier",
                    DescriptionOverride = "Ready For Action.",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("Hazmat_Tactical_Zombie_Thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("Hazmat_Tactical_Zombie_Skin.png");
                        var flesh = ModAPI.LoadTexture("humanflesh.png");
                        var bone = ModAPI.LoadTexture("humanbone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
						
						var person = Instance.GetComponent<PersonBehaviour>();

			            
			            person.SetBodyTextures(skin, null, null, 1);

			            
			            person.SetBruiseColor(119, 17, 17); 
			            person.SetSecondBruiseColor(7, 0, 0); 
			            person.SetThirdBruiseColor(3, 0, 0); 
			            person.SetRottenColour(202, 199, 104); 
			            person.SetBloodColour(108, 0, 4); 
				        foreach(var body in person.Limbs)
                        {
                            body.GetComponent<SkinMaterialHandler>().RottenProgress = 100f;
                            body.IsZombie = true;
                        }
                    }
                }
            );
	        ModAPI.Register(
                 new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "SAS Mod Elite Infected Soldier",
                    DescriptionOverride = "Ready For Action.",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("Elite_Zombie_Thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("Elite_Zombie_Skin.png");
                        var flesh = ModAPI.LoadTexture("humanflesh.png");
                        var bone = ModAPI.LoadTexture("humanbone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
						
						var person = Instance.GetComponent<PersonBehaviour>();

			            
			            person.SetBodyTextures(skin, null, null, 1);

			            
			            person.SetBruiseColor(119, 17, 17); 
			            person.SetSecondBruiseColor(7, 0, 0); 
			            person.SetThirdBruiseColor(3, 0, 0); 
			            person.SetRottenColour(202, 199, 104); 
			            person.SetBloodColour(108, 0, 4); 
				        foreach(var body in person.Limbs)
                        {
                            body.GetComponent<SkinMaterialHandler>().RottenProgress = 100f;
                            body.IsZombie = true;
                        }
                    }
                }
            );
	        ModAPI.Register(
                 new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "SAS Mod Navy Infected Soldier",
                    DescriptionOverride = "Ready For Action.",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("Navy_Zombie_Thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("Navy_Zombie_Skin.png");
                        var flesh = ModAPI.LoadTexture("humanflesh.png");
                        var bone = ModAPI.LoadTexture("humanbone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
						
						var person = Instance.GetComponent<PersonBehaviour>();

			            
			            person.SetBodyTextures(skin, null, null, 1);

			            
			            person.SetBruiseColor(119, 17, 17); 
			            person.SetSecondBruiseColor(7, 0, 0); 
			            person.SetThirdBruiseColor(3, 0, 0); 
			            person.SetRottenColour(202, 199, 104); 
			            person.SetBloodColour(108, 0, 4); 
				        foreach(var body in person.Limbs)
                        {
                            body.GetComponent<SkinMaterialHandler>().RottenProgress = 100f;
                            body.IsZombie = true;
                        }
                    }
                }
            );
	        ModAPI.Register(
                 new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "SAS Mod Spec Ops Infected Soldier",
                    DescriptionOverride = "Ready For Action.",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("Spec_Ops_Zombie_Thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("Spec_Ops_Zombie_Skin.png");
                        var flesh = ModAPI.LoadTexture("humanflesh.png");
                        var bone = ModAPI.LoadTexture("humanbone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
						
						var person = Instance.GetComponent<PersonBehaviour>();

			            
			            person.SetBodyTextures(skin, null, null, 1);

			            
			            person.SetBruiseColor(119, 17, 17); 
			            person.SetSecondBruiseColor(7, 0, 0); 
			            person.SetThirdBruiseColor(3, 0, 0); 
			            person.SetRottenColour(202, 199, 104); 
			            person.SetBloodColour(108, 0, 4); 
				        foreach(var body in person.Limbs)
                        {
                            body.GetComponent<SkinMaterialHandler>().RottenProgress = 100f;
                            body.IsZombie = true;
                        }
                    }
                }
            );
		}
    }
}